' @(#)15  1.1  src/hc/client/collectors/C/vbs/gpo.vbs, hc.collectors.win, scmweb, 100921a  9/14/10  03:52:55
' IBM Confidential
' OCO Source Materials
'
' 5724-F82
'
' (C) Copyright IBM Corp. 2010
'
' The source code for this program is not published or otherwise
' divested of its trade secrets, irrespective of what has been
' deposited with the U.S. Copyright Office.

Sub PrintArray(ByRef vArray)
	If UBound(vArray) = -1 Then 
		Wscript.Echo "value:null"
		Exit Sub
	End If
	out=""
	s1=""
    For i = LBound(vArray) To UBound(vArray)
      if i = 0	Then
      		out = CStr(Hex(vArray(0)))
      		if vArray(0) < 10 then out = "0"+out
      Else 
      		If vArray(i) < 10 then
      			out = out+"0" + CStr(Hex(vArray(i)))
      		Else
      			out = out+ CStr(Hex(vArray(i)))
      		End If
      End If
	Next
	out = "0x" + out
	Wscript.Echo "value: " & out
End Sub

Const FL_FORCE_CREATE_NAMESPACE = 5

strComputer = "."
Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate,AuthenticationLevel=default}!\\" & strComputer & "\root\rsop")
Set provider = objWMIService.Get("RsopLoggingModeProvider") 
provider.RsopCreateSession FL_FORCE_CREATE_NAMESPACE, Null, namespaceLocation, hResult, eInfo
Wscript.Echo "namespace " & namespaceLocation
Wscript.Echo "hresult " & hresult
Wscript.Echo "eInfo " & eInfo
strNamespaceName = Mid(namespaceLocation, 4)
Set rsopProv = GetObject("winmgmts:{impersonationLevel=impersonate,AuthenticationLevel=default}!\\" & strComputer & strNamespaceName & "\computer")

rem Set rsopProv = locator.ConnectServer (strComputer, namespaceLocation & "\Computer", null, null, Null, Null, 0 , Null)

Rem Wscript.Echo "List all GPOLink"
Rem Set colItems = rsopProv.ExecQuery("Select * from RSOP_GPLink")

Rem For Each objItem in colItems
Rem    Wscript.Echo "GPO: " & objItem.GPO
Rem    Wscript.Echo "Applied Order: " & objItem.AppliedOrder
Rem    Wscript.Echo "Enabled: " & objItem.Enabled
Rem    Wscript.Echo "Link Order: " & objItem.LinkOrder
Rem    Wscript.Echo "No Overrride: " & objItem.NoOverride
Rem    Wscript.Echo "SOM Order: " & objItem.SOMOrder
Rem    Wscript.Echo " "
Rem Next

Wscript.Echo "List all GPOs"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_GPO")
For Each objItem in colItems  
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "enabled: " & objItem.enabled
    Wscript.Echo "guidName: " & objItem.guidName
    Wscript.Echo "name: " & objItem.name
    Wscript.Echo "version: " & objItem.version
	Wscript.Echo " "
Next

Wscript.Echo "List Registry Policy settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_RegistryPolicySetting Where Precedence = 1")
For Each objItem in colItems  
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "registryKey: " & objItem.RegistryKey
    Wscript.Echo "valueType: " & objItem.valueType
    If isNull(objItem.value) Then
    	Wscript.Echo "value: null" 
    Else 
    	PrintArray objItem.value
    End If
	Wscript.Echo "valueName: " & objItem.valueName
    Wscript.Echo "SOMID: " & objItem.SOMID
	Wscript.Echo " "
Next

Wscript.Echo "List Registry Value settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_RegistryValue Where Precedence = 1")
For Each objItem in colItems  
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Path: " & objItem.Path
    Wscript.Echo "Data: " & objItem.Data
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "Type: " & objItem.Type
	Wscript.Echo " "
Next

Wscript.Echo "List Registry Key settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_RegistryKey Where Precedence = 1")
For Each objItem in colItems  
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Path: " & objItem.Path
    Wscript.Echo "Mode: " & objItem.Mode
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "SDDLString: " & objItem.SDDLString
	Wscript.Echo " "
Next

Wscript.Echo "List Security Boolean settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_SecuritySettingBoolean Where Precedence = 1")

For Each objItem in colItems
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Key Name: " & objItem.KeyName
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "Setting: " & objItem.Setting
	Wscript.Echo " "
Next

Wscript.Echo "List Security Numeric Settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_SecuritySettingNumeric Where Precedence = 1")

For Each objItem in colItems
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Key Name: " & objItem.KeyName
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "Setting: " & objItem.Setting
	Wscript.Echo " "
Next

Wscript.Echo "List System Services GPO settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_SystemService Where Precedence = 1")

For Each objItem in colItems
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Service: " & objItem.Service
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "SDDL String: " & objItem.SDDLString
    Wscript.Echo "Startup Mode: " & objItem.StartupMode
	Wscript.Echo " "
Next

Wscript.Echo "List EventLog Boolean Settings"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_SecurityEventLogSettingBoolean Where Precedence = 1")
For Each objItem in colItems
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Key Name: " & objItem.KeyName
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "Setting: " & objItem.Setting
    Wscript.Echo "Type: " & objItem.Type
	Wscript.Echo " "
Next

Set colItems = rsopProv.ExecQuery("Select * from RSOP_SecurityEventLogSettingNumeric Where Precedence = 1")

For Each objItem in colItems
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Key Name: " & objItem.KeyName
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "Setting: " & objItem.Setting
    Wscript.Echo "Type: " & objItem.Type
    Wscript.Echo " "

Next


Wscript.Echo "List Audit Settings applied"
Set colItems = rsopProv.ExecQuery("Select * from RSOP_AuditPolicy Where Precedence = 1")

For Each objItem in colItems  
    Wscript.Echo "id: " & objItem.id
    Wscript.Echo "gpoid: " & objItem.gpoid
    Wscript.Echo "Name: " & objItem.Name
    Wscript.Echo "Status: " & objItem.Status
    Wscript.Echo "Category: " & objItem.Category
    Wscript.Echo "Precedence: " & objItem.Precedence
    Wscript.Echo "Failure: " & objItem.Failure
    Wscript.Echo "Success: " & objItem.Success
	Wscript.Echo " "
Next

provider.RsopDeleteSession namespaceLocation, hResult
Set ObjWMIService = Nothing
Set provider = Nothing
Set rsopProv = Nothing
Set colItems = Nothing