' @(#)10  1.15  src/hc/client/collectors/C/vbs/screensaver.vbs, hc.collectors.win, scmweb, 090218a  2/13/09  07:20:21
' IBM Security Compliance Manager
' 5724-F82                       
' (C) IBM, 2007.                 
' All Rights Reserved            
' Licensed Materials - Property of IBM 
'
' US Government Users Restricted Rights - Use, duplication or 
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
' TPM Development
'
on error resume next

Const ROLE_STANDALONE_WST = 0
Const ROLE_MEMBER_WST = 1
Const ROLE_STANDALONE_SVR = 2
Const ROLE_MEMBER_SVR = 3
Const ROLE_BACKUP_DC = 4
Const ROLE_PRIMARY_DC = 5

dim strComputer
dim strOnlyLoggedOn
dim regCommand
dim table(4)
dim isWinXP
dim isWin2k
dim compName
dim compRole
dim isStandalone

if Wscript.Arguments.Named.Exists("osname") then 
   if Wscript.Arguments.Named.Item("osname") = "winxp" then
      isWinXP = "True"
   end if
   if Wscript.Arguments.Named.Item("osname") = "win2k" then
      isWin2k = "True"
   end if
end if

const wFlagReturnImmed = &h10
const wFlagFwdOnly = &h20

Function RegistryValue(regkey)
   on Error resume next
   set sh = Wscript.CreateObject("WScript.Shell")
   RegistryValue = sh.RegRead(regKey)

   if not Err.number=0 then
     RegistryValue = "[ERROR:" & Err.description & "]"
   end if   
 ' Wscript.echo regKey & "=" & RegistryValue
End Function



if Wscript.Arguments.Named.Exists("computer") then
  strComputer=Wscript.Arguments.Named.Item("computer")
else
  strComputer="."
end if

if Wscript.Arguments.Named.Exists("regtool") then
  regCommand=Wscript.Arguments.Named.Item("regtool")
else
  regCommand=".\regtool.exe"
end if

set objWMIService= GetObject("winmgmts:\\" & strComputer & "\root\CIMV2")


LUCnt = 0

'Wscript.Echo "[START LOGGEDONUSERS]"
 set colComputer = objWmiService.ExecQuery("SELECT * FROM Win32_ComputerSystem","WQL",wFlagReturnImmed + wFlagFwdOnly)
 For Each objComputer in colComputer
    str1 =  objComputer.UserName
    compName = objComputer.Name        
	compRole = objComputer.DomainRole

	table(i) = UCase(str1)
	LUCnt = LUCnt+1
 next
'Wscript.Echo "[END LOGGEDONUSERS]"

Err.Clear


dim Domain
set ds = Wscript.CreateObject("Wscript.Network")
Domain = ds.UserDomain
' Wscript.Echo "Domain=" & Domain

set sh= Wscript.CreateObject("WScript.Shell")
profileDir = sh.RegRead("HKLM\SOFTWARE\Microsoft\Windows Nt\CurrentVersion\ProfileList\ProfilesDirectory")

dim wasBad
dim userSid
dim value
dim val1
dim val2
dim val3
  
myval = "reset"
  
'check if regtool.exe is accessible - if not return error and quit
set lExec=sh.Exec(regCommand)
If not Err.Number = 0 Then
	Wscript.Echo "[REGTOOL ERROR]=Error: " & Err.description
	WScript.Quit
end if

isStandalone = (NOT ((compRole = ROLE_BACKUP_DC) OR (compRole = ROLE_PRIMARY_DC)))

Wscript.Echo "[START INFO]"

  'set allUsers= objWMIService.ExecQuery("SELECT * from Win32_UserAccount where Disabled='False'","WQL",wFlagReturnImmed + wFlagFwdOnly)
  Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\"& strComputer &"\root\default:StdRegProv")
  path = "SOFTWARE\Microsoft\Windows Nt\CurrentVersion\ProfileList"
  oReg.EnumKey &H80000002, path, arrSubKeys

'for each anUser in allUsers
for each subkey in arrSubKeys 
     Err.Clear
     wasBad = 0   

	 userSid = subkey
     userName=GetUserNameFromSid(userSid)
     userDomain=GetDomainNameFromSid(userSid)
     
	 'if isWin2k = "True" then 
        if userDomain = compName then 
           isLocalUser = "True"
        else 
           isLocalUser = "False"
        end if 
     'else  
	    'isLocalUser=anUser.LocalAccount
     'end if
     
     for i = 0 to (LUCnt-1)
		domUsrName = GetDomainNameFromSid(userSid) &"\"& GetUserNameFromSid(userSid)
		domUsrName = UCase(domUsrName)
		'WScript.Echo "=========" & userSid & " " & domUsrName
		if domUsrName = table(i) then
			isLogged = 1 
		end if
	 next

	 
	 ' If userName not empty or SID is NOT well know (omitting system builtin accounts)
	 if ( (not (userName="")) AND (Ubound(Split(userSid, "-"))>4)) Then
     
       Myhive="HKLM\SOFTWARE\Microsoft\Windows Nt\CurrentVersion\ProfileList\" & userSid & "\ProfileImagePath"
       myval = sh.RegRead(Myhive)

       if not myval="reset" then
    
       Wscript.Echo "userName=" & userName
       ' Wscript.Echo "  userSID=" & userSid

       regKeyName = "HKEY_USERS\" & userSid & "\Software\Policies\Microsoft\Windows\Control Panel\Desktop\ScreenSaveActive"
       ' value = sh.RegRead(regKeyName) 
       value=registryValue(regKeyName)
     
       if Err.number=0 then
         Wscript.Echo "Active(policy)=" & value
       else     
         'if not Err.number=0 then
         Err.clear
         isGroup = 0
         regKeyName = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\ScreenSaveActive"
         'value = sh.RegRead(regKeyName)
         value = RegistryValue(regKeyName)
       
         if Err.number=0 then
           Wscript.Echo "Active(local)=" & value   
         else
		   wasBad = 1
           'if not Err.number=0 then
           ' Wscript.Echo "Error: " & Err.description
           Err.Clear
           hiveName=profileDir & "\" & userName & "." & userDomain & "\NTUSER.DAT"
           'Wscript.Echo "hiveName=" & hiveName
         
           cmd = regCommand & " load HKEY_USERS tempUser """ & hiveName & """"
           'Wscript.Echo "cmd=" & cmd
           set lExec=sh.Exec(cmd)
           Do While lExec.Status = 0
             Wscript.Sleep 100
           Loop
           
           if lExec.ExitCode <> 0 then
             'hiveName=profileDir & "\" & userName & "\NTUSER.DAT"
             hiveName=myval & "\NTUSER.DAT"
             ' Wscript.Echo "hiveName=" & hiveName
         
             cmd = regCommand & " load HKEY_USERS tempUser """ & hiveName & """"
             ' Wscript.Echo "cmd=" & cmd
             set lExec=sh.Exec(cmd)
             Do While lExec.Status = 0
               Wscript.Sleep 100
             Loop
           end if 
         
           userSid = "tempUser"
           if not Err.number=0 then
             'Wscript.Echo "ERROR: "& Err.description
             Err.Clear
           end if
         
           regKeyName = "HKEY_USERS\" & userSid & "\Software\Policies\Microsoft\Windows\Control Panel\Desktop\ScreenSaveActive"
           value=registryValue(regKeyName)
           
           if Err.number=0 then
             Wscript.Echo "Active(policy)=" & value
           else
             'if not Err.number=0 then
             regKeyName = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\ScreenSaveActive"
             'value = sh.RegRead(regKeyName)
             value= RegistryValue(regKeyName)
             if not Err.number = 0 then
               Err.Clear
               userSid = ".DEFAULT"
               regKeyName = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\ScreenSaveActive"
               'value = sh.RegRead(regKeyName)
               value = RegistryValue(regKeyName)
             end if
             
             Wscript.Echo "Active(local)=" & value
           end if 
           
         end if
         'Wscript.Echo "Active(local)=" & value   
       end if

       Err.Clear
      
       regKeyName2 = "HKEY_USERS\" & userSid & "\Software\Policies\Microsoft\Windows\Control Panel\Desktop\ScreenSaverIsSecure"     

       'val2 = sh.RegRead(regKeyName2)
       val2 = RegistryValue(regKeyName2)
     
       if not Err.number=0 then      
         if isWinXP = "True" then
           regKeyName2a = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\ScreenSaverIsSecure"
           regKeyName2b = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\NoAutoreturnToWelcome"
           regKeyName2c = "HKLM\SOFTWARE\Microsoft\Windows Nt\CurrentVersion\Winlogon\LogonType"
           regKeyName2d = "HKLM\SOFTWARE\Microsoft\Windows Nt\CurrentVersion\Winlogon\AllowMultipleTSSessions"
           
           val2a = RegistryValue(regKeyName2a)
           val2b = RegistryValue(regKeyName2b)
           val2c = RegistryValue(regKeyName2c)
           val2d = RegistryValue(regKeyName2d)
           
           if val2b <> "1" and val2c = "1" and val2d = "1" then 
             val2 = "1"
           else
             val2 = val2a
           end if     
         else 
           regKeyName2 = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\ScreenSaverIsSecure"    
           'Wscript.Echo "regKeyName2=" & regKeyName2
           'val2 = sh.RegRead(regKeyName2)
           val2 = RegistryValue(regKeyName2)
         end if
       end if
       Wscript.Echo "Secure=" & val2
       'Wscript.Echo "Active=" & value

       Err.clear   
       regKeyName3 = "HKEY_USERS\" & userSid & "\Software\Policies\Microsoft\Windows\Control Panel\Desktop\ScreenSaveTimeOut"
       'val3 = sh.RegRead(regKeyName3)
       val3 = RegistryValue(regKeyName3)
       if not Err.number=0 then
         regKeyName3 = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\ScreenSaveTimeOut"
         'val3 = sh.RegRead(regKeyName3)
         val3 = RegistryValue(regKeyName3)
       end if
       Wscript.Echo "Timeout=" & val3
     
       Err.clear   
       regKeyName4 = "HKEY_USERS\" & userSid & "\Software\Policies\Microsoft\Windows\Control Panel\Desktop\SCRNSAVE.EXE"
       'val4 = sh.RegRead(regKeyName4)
       val4 = RegistryValue(regKeyName4)
       if not Err.number=0 then
         regKeyName4 = "HKEY_USERS\" & userSid & "\Control Panel\Desktop\SCRNSAVE.EXE"
         'val4 = sh.RegRead(regKeyName4)
         val4 = RegistryValue(regKeyName4)
       end if
       Wscript.Echo "File=" & val4

	   if isLogged = 1 then
		  Wscript.Echo "Loggedin=1"
	   else 
		  Wscript.Echo "Loggedin=0"
	   end if
	   isLogged = 0
	 
	   if isLocalUser = "True" then
	     Wscript.echo "IsLocal=1"
	   else 
		 Wscript.echo "IsLocal=0"
	   end if
       Wscript.echo "Domain=" & userDomain
	 
       if not wasBad = 0 then 
         cmd = regCommand & " unload HKEY_USERS tempUser" 
         ' Wscript.Echo "cmd=" & cmd
         set rExec=sh.Exec(cmd)
         Do While rExec.Status = 0
           Wscript.Sleep 100
         Loop
         'Wscript.Echo "HiveLoaded=1"
       else
        'Wscript.Echo "HiveLoaded=0"
       end if
     
       myval = "reset"
     end if
     
   end if
  next
Wscript.Echo "[END INFO]"

Function GetUserNameFromSid(sid)
	Set wmi = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
	Set obj = wmi.Get("Win32_SID.SID='" & sid & "'")
	strName = obj.AccountName
	GetUserNameFromSid = obj.AccountName
End Function

Function GetDomainNameFromSid(sid)
	Set wmi = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
	Set obj = wmi.Get("Win32_SID.SID='" & sid & "'")
	GetDomainNameFromSid = obj.ReferencedDomainName
End Function

 