' %Z%%M%    %I%  %W%  %G%  %U%
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2005.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

On Error Resume Next
Err.Clear

Const wbemFlagReturnImmediately = &h10
Const wbemFlagForwardOnly = &h20

if WScript.Arguments.Named.Exists("WMI_CLASS") then
  wmi_class = WScript.Arguments.Named.Item("WMI_CLASS")
else
  WScript.Echo "Usage: cimv2.vbs /WMI_CLASS:class [/KEY:value /computer:value]"
  WScript.Quit(1)
end if

computerName = "."
if WScript.Arguments.Named.Exists("computer") then
  computerName = WScript.Arguments.Named.Item("computer")
end if

keyProperty = ""
if WScript.Arguments.Named.Exists("key") then
  keyProperty = WScript.Arguments.Named.Item("key")
end if

url = "winmgmts:\\" & computerName & "\root\CIMV2"
Set objWMIService = GetObject(url)

select1 = keyProperty
if select1="" then
	select1="*"
end if
Set colItems = objWMIService.ExecQuery("SELECT " & select1 & " FROM " & wmi_class, "WQL", _
                                          wbemFlagReturnImmediately + wbemFlagForwardOnly)
For Each objItem In colItems
  if keyProperty <> "" then
    Set keyItem = objItem.Properties_.Item(keyProperty)
    if keyItem.IsArray then
        WScript.Echo "Key = " & Join( keyItem, "," )
    else
    	WScript.Echo "Key = " & keyItem
    end if
  end if
  for each property in objItem.Properties_
    WScript.Echo "Name  = " & property.name
      if not IsNull( property ) then
        if property.IsArray then
          WScript.Echo "Value = " & Join( property, "," )
        else
          WScript.Echo "Value = " & property.value
      end if
    end if
  Next
  WScript.Echo
Next

