' @(#)48    1.6  src/hc/client/collectors/C/vbs/tav.vbs, hc.collectors.win, scmweb, 090423a  4/23/09  08:43:53
' IBM Security Compliance Manager
' 5724-F82
' (C) IBM, 2005.
' All Rights Reserved
' Licensed Materials - Property of IBM
'
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

On Error Resume Next
Err.clear

Function printRegistryValue(regkey)

   On Error Resume Next
   value = getRegistryValue(regkey)
   if Err.number=0 then
     Wscript.Echo regkey & "=" & value
   else
     Wscript.Echo regkey & "=[ERROR:" & Err.description & "]"
     Err.clear
   end if

End Function

Function getRegistryValue(regkey)

  On Error Resume Next
  set sh = Wscript.CreateObject("WScript.Shell")
  getRegistryValue = sh.RegRead(regkey)

End Function

Dim strComputer
Dim cmdStr
Dim objWMIService
Dim colListOfServices
Dim objItem
Dim property
Dim sh
Dim installed


strComputer = "."

cmdStr= "winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2"

Set objWMIService = GetObject(cmdStr)
installed = null

Set colListOfServices = objWMIService.ExecQuery( "Select State, StartMode from Win32_Service where name='ntrtscan'")

 For Each objItem in colListOfServices
    installed="installed"
    Wscript.Echo "[SERVICE]"
    for each property in objItem.Properties_
      if not IsNull(property) then
        if property.IsArray then
           Wscript.Echo objItem.name & "." & property.name & "=" & Join( property,",")
        else
           Wscript.Echo objItem.name & "." & property.name & "=" & property.value
        end if
     end if
   Next
 Next

if IsNull(installed)  then
  Wscript.Echo "[NOT INSTALLED]"
else
  Wscript.Echo "[INSTALLED]"


  printRegistryValue("HKLM\SYSTEM\CurrentControlSet\Services\ntrtscan\Start")



'  printRegistryValue("HKLM\SYSTEM\CurrentControlSet\Services\ntrtscan\DisplayName")
'  printRegistryValue("HKLM\SYSTEM\CurrentControlSet\Services\ntrtscan\ErrorControl")
'  printRegistryValue("HKLM\SYSTEM\CurrentControlSet\Services\ntrtscan\ImagePath")
'  printRegistryValue("HKLM\SYSTEM\CurrentControlSet\Services\ntrtscan\ObjectName")
'  printRegistryValue("HKLM\SYSTEM\CurrentControlSet\Services\ntrtscan\Type")
'


  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Application Path")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\InstDate")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Install Completed")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\InstTime")
'


  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\ProgramVer")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\VsApiNT-Ver")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\PatternDate")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\InternalPatternVer")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\Running")



'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\EngineZipVer")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\LastInfectedAction")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\LastInfectedDateTime")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\LastInfectedFileName")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\LastInfectedVirusName")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\TotalInfected")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\TSC-Ver")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\Allow Uninstall")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\AllowStopScheduleScan")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\PatternTooOldDays")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\PatternTooOldWarningOnOff")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\PatternVer")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\PatternVer1")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\UpdateAgent")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\UpdateFrom")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\VLogThrottleCnt")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\TmFilter-Ver")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Misc.\HotFix")




  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Schedule Clean\ScheduleCleanInterval")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\PC-cillinNTCorp\CurrentVersion\Schedule Clean\LastCleanTime")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\DayOfMonth")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\DayOfWeek")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\Enable")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\Frequency")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\Hour")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\Minute")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\StartHourly")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\TriggerPeriod")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\OfficeScan\service\Scheduled_Update\Update_Flag")



  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\Enable")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\EnableExclusion")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\EnableUniAct")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ExcludeDatabaseFolder")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\Home Directory")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\IntelliScan")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\LastStatusCode")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ScanAllFiles")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ScanIncoming")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ScanNetwork")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ScanOutgoing")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ScanShutDown")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ScanSpyware")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\WatchDogOnOff")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Real Time Scan Configuration\ZipCleanOnOff")




  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\TimeStamp")
  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\ScheduleUpdateInterval")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\AllowScheduleUpdate")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\EnableDisable")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\ScheduledUpdateWithConfigOncePerDay")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\ScheduleUpdateCompletePeriod")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\ScheduleUpdateStartHour")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\ScheduleUpdateStartMin")
'  printRegistryValue("HKLM\SOFTWARE\TrendMicro\Pc-cillinNTCorp\CurrentVersion\Schedule Update\ScheduleUpdateStartWeekDay")

end if